/*------------------------------------------------------------------------------
	wi摜ǂݍ݁` for HSP Script Editor by inovia
	쐬 2015.01.09
	C 2015.04.29
------------------------------------------------------------------------------*/

#include <windows.h>
#include <gdiplus.h>
#include <olectl.h>
#pragma once
#pragma	comment(lib, "Gdiplus.lib")
#include "ImageController.h"

// RXgN^
CImageController::CImageController(HWND hwnd){

	m_Load = FALSE;
	m_Bmp = NULL;
	m_Color = 0x00000000;
	m_g = NULL;

	HDC hdc;
	hdc = GetDC(hwnd);
	m_hWnd = hwnd;

	/* GDI+ */
	Gdiplus::GdiplusStartup(&m_lpToken, &m_pSI, NULL);

	// ItXN[DC(fXNgbṽTCYō쐬܂)
	m_hDrawDC = CreateCompatibleDC(hdc);
	GetClientRect(GetDesktopWindow(), &m_DesktopRect);

	HBITMAP hDrawBmp;
	hDrawBmp = CreateCompatibleBitmap(hdc, m_DesktopRect.right, m_DesktopRect.bottom);
	SelectObject(m_hDrawDC, hDrawBmp);
	DeleteObject(hDrawBmp);

}
	
// fXgN^
CImageController::~CImageController(void){

	Destroy();

	// ItXN[DCj
	if(m_hDrawDC){
		DeleteDC(m_hDrawDC);
		m_hDrawDC = NULL;
	}

	/* j */
	Gdiplus::GdiplusShutdown(m_lpToken);
}

BOOL CImageController::Load(const WCHAR *fileName){

	this->Destroy();

	/* t@CpX̕񂩂Bitmap쐬 */
	m_Bmp = NULL;
	m_Bmp = new Gdiplus::Bitmap(fileName);
	if(m_Bmp != NULL && m_Bmp->GetLastStatus() == Gdiplus::Ok){
		m_g = new Gdiplus::Graphics(m_hDrawDC);
		this->Update();
		m_Load = TRUE;
		return TRUE;
	}
	this->UnLoad();

	return FALSE;
}

// Iɔjꍇ
void CImageController::Destroy(void){

	if (m_Bmp != NULL && m_Bmp->GetLastStatus() == Gdiplus::Ok){
		delete(m_Bmp);
		m_Bmp = NULL;
		if (m_g != NULL){
			delete(m_g);
			m_g = NULL;
		}
	}

}

void CImageController::Update(void){
	// EŔzui}CiXɂȂꍇ0ɂj
	LONG posX = m_DesktopRect.right - m_Bmp->GetWidth();
	LONG posY = m_DesktopRect.bottom - m_Bmp->GetHeight();
	if (posX < 0)
		posX = 0;
	if (posY < 0)
		posY = 0;

	// wiNA
	this->Clear();

	// ItXN[DCɕ`
	if(Gdiplus::Ok != m_g->DrawImage(m_Bmp, posX, posY)){
		FOOTY2_PRINTF(L"CImageController::Update() GDI+`Ɏs܂");
	}
}

void CImageController::Clear(COLORREF color){
	// wi
	HPEN hPen, hOldPen;
	HBRUSH hBrush, hOldBrush;
	
	hPen = CreatePen(PS_SOLID, 1, color);
	hOldPen = (HPEN)SelectObject(m_hDrawDC, hPen);
	hBrush = CreateSolidBrush(color);
	hOldBrush = (HBRUSH)SelectObject(m_hDrawDC, hBrush);

	if (FALSE == Rectangle(m_hDrawDC, 0, 0, m_DesktopRect.right, m_DesktopRect.bottom)){
		FOOTY2_PRINTF(L"CImageController::Clear() GDI`Ɏs܂");
	}

	SelectObject(m_hDrawDC, hOldPen);
	SelectObject(m_hDrawDC, hOldBrush);
	DeleteObject(hPen);
	DeleteObject(hBrush);
}

void CImageController::Clear(void){
	// wi
	this->Clear(m_Color);
}

void CImageController::UnLoad(void){
	this->Clear();
	this->Destroy();
	m_Load = FALSE;
}

void CImageController::Draw(HDC targetHDC, int x1, int y1, int x2, int y2, int maxWidth, int maxHeight){
	// `TCY
	int width = x2 - x1;
	int height = y2 - y1;

	int drawWidth =  m_DesktopRect.right  - (maxWidth - x2) - width;
	int drawHeight = m_DesktopRect.bottom - (maxHeight - y2) - height;

	if (FALSE == BitBlt(targetHDC, x1, y1, width, height, m_hDrawDC, drawWidth, drawHeight, SRCCOPY)){
		FOOTY2_PRINTF(L"CImageController::Draw() GDI`Ɏs܂");
	}
}

void CImageController::Draw(HDC targetHDC, int x1, int y1, int x2, int y2){
	this->Draw(targetHDC, x1, y1 ,x2, y2, 0, 0);
}